; dioda.asm: didavlogat

	list		p=16f1704   
	list		r=dec
	#include	<p16f1704.inc> 

    __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _BOREN_ON & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
    __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _BORV_HI & _STVREN_OFF &  _LVP_OFF
    
    #INCLUDE	<PRLX.INC>	; parallax stlus makrk gyjtemnye

	CBLOCK	0X20	; csak nulls (nincs ilyen)
	ENDC
	
	CBLOCK	0X70	; MINDENHONNAN LTHAT , 13 db
	ah
	al
	bh
	bl
	ch
	cl
	flags		; jelzbitek
	samples		; mintaszmll
	mcnt		; mrsszmll
	objcnt		; objektumszmll
	asccnt
	aux
	dcnt
	ENDC
	
	CBLOCK	0XA0	; A/D MUNKAREGISZTEREK ADC LAPJN,3 db
	adacch
	adaccl
	adcnt
	ENDC
	
	CBLOCK	0X1A0	; ASCII BUFFER, SOROS PORT LAPJN
	ascbuf:60	; amibl csak 51-et hasznlok, de hely van elg
	ENDC		; NINCS TBB VLTOZ

; bemen bitek
; mux bitjei	
#define	inh	porta,2	; a multiplexer kln kezelt inh bemenete
#define	m_start	porta,4	; mrsindt bemenet
#define	m_stop	porta,3	; lellt (EOF) bemenet
#define	range	porta,5	; mrshatr: 0=4,095V (pl.LED-hez), 1=1,023V 
; soros kapcsolat rzkels
#define	sense	portc,3	; hasznlaton kvl
; egyb bitek
#define adgo	adcon0,go_not_done	; A/D ciklus vezrl bitje
#define	sok	flags,7	; az eredmny taln nagyobb a mrshatrnl
#define car	flags,6	; trolt tvitel
#define test	flags,5
; specilis karakterek
s_c	equ	0x3b	; pontosvessz (semicolon), mert az sc foglalt
sp	equ	0x20	; space
cr	equ	0x0d	; carriage return
lf	equ	0x0a	; line feed
eof	equ	0x1a	; eof
; egyb
buflen	equ	51	; ascbuf leadand hossza bjtban szmolva

	org     0x0000            
	movlp	0
 	banksel	0
 	clrf	intcon
 	goto    start             

	org      0x0004	; egyelre nem kell megszakts
	banksel	porta
	pagesel	its
	goto	its
	
	org	7
bcurr		; vlaszt tbla (fordtott bjt- s bitsorrend)	
	brw
	dt	7, 3, 5, 1, 6, 2, 4, 0

start
	movlw	0x0c
	movwf	porta
	movlw	8
	movwf	portc
	clrf	flags
	banksel	wpua
	movlw	0x38
	movwf	wpua
	movlw	8
	movwf	wpuc
	banksel	ansela
	movlw	3
	movwf	ansela
	clrf	anselc
	banksel	trisa
	bcf	option_reg,7
	movlw	0x3b
	movwf	trisa
	movlw	0x28
	movwf	trisc
	banksel	osccon
	movlw	0x68
	movwf	osccon	; 4 MHz
	banksel	rxpps
	movlw	0x15
	movwf	rxpps
	banksel	rc4pps
	movlw	0x14
	movwf	rc4pps
	banksel	adcon0
	movlw	0xc2
	movwf	adcon1
	movlw	1
	movwf	adcon0
	call	serini
; ez a rsz egy 250 us-onknti megszaktst kszt el, de ezt az
; alapvltozat nem hasznlja. Ksbb szerepet kaphat idztsekben:
	banksel	0
	movlw	249
	movwf	pr2
	movlw	4
	movwf	t2con
	movlw	high ascbuf	; fsr1 mindig ezt cmzi
	movwf	fsr1h
; lthatan nincs is engedlyezve a megszakts.
main	
	clrf	objcnt	; nulls sorszmmal indul, a didkat szmllja
	sb	m_stop
	goto	testrun	; stop a start helyett nyomva a tesztgra ugrik
	snb	m_start
	goto	main	; egybknt megvrja a start gombot
; bejtt az indt gombnyoms. Eltte az 1 uA folyt ismeretlen ideje.
; hosszabb tevkenysg jn, ami alatt a gombok llapota kzmbs.
; els mrs, inh=1, a tbbi bit kzmbs

first
	incf	objcnt,f	; hogy 1 legyen az els
	clrf	asccnt
	movf	objcnt,w
	call	bdwu
	movlw	low ascbuf
	movwf	fsr1l
	movf	ah,w
	movwi	fsr1++
	movf	al,w
	movwi	fsr1++
	movf	bh,w
	movwi	fsr1++
	movlw	s_c
	movwi	fsr1++	; sorszm s pontosvessz a helyn
alap	
	call	ad8
	movlw	8
	movwf	mcnt
	snb	test
	call	chkst
; mrsi ciklus: 8(x4) tovbbi mrs, ram bitek tblzatbl	
mcyc
	banksel	lata
	movlw	0x38
	andwf	latc,f	; latc als 3 bitje 0 (ettl lesz a 8 us tske)
	decf	mcnt,w	; 7-tl 0-ig fog cmezni
	call	bcurr	; behozza a hrom ram mux bitet (a tbbi nulla)
	iorwf	latc,f	; trakja latc vgre
	bcf	inh	; rvnyesti a mux kimenetet
	banksel	0
	movlw	45
	call	delay+1	; vr kb. 0,5 ms-ot
	call	ad8	; lezavar nyolc mrst tlagolssal
	snb	test
	call	chkst
	call	delay
	decfsz	mcnt,f
	goto	mcyc	; s zrja a ciklust, amg mcnt el nem fogy
	banksel	lata
	movlw	0x38
	andwf	latc,f
	banksel	0
	movlw	cr
	movwi	fsr1++
	movlw	lf
	movwi	fsr1++
	call	txblk	; ha elfogyott, kikldi a sort, 
	banksel	0
	bcf	test
mslp
	btfss	m_start	; s gombokat vizsgl
	goto	mslp	; amg alacsony, marad a hurokban
	call	delay
	call	delay
	call	delay
	call	delay
	btfss	m_start
	goto	mslp
mplp
	sb	m_stop
	goto	utso	; a stop gomb szerepe most ms lesz
	btfss	m_start
	goto	first	; jra megnyomtk a startot
	goto	mplp
utso
	movlw	eof
	call	sersendw	; a stop gomb most EOF karaktert kld
	call	delay		; stop gomb pergsmentestsi kisrlet
	call	delay
	call	delay
	call	delay
	call	delay
	call	delay
	call	delay
	call	delay
	call	delay
ulp
	call	delay
	sb	m_stop
	goto	ulp
	goto	main	

delay			; valamivel tbb, mint 250*11 us
	movlw	250
	movwf	dcnt
dcyc
	call	dum
	call	dum
	decfsz	dcnt,f
	goto	dcyc
dum
	return

chkst
	sb	m_start
	goto	chkst
again
	call	delay
	snb	m_start
	goto	again
	return	

ad1	
	bsf	adgo
adlp
	btfsc	adgo
	goto	adlp
	movf	adresl,w
	addwf	adaccl,f
	movf	adresh,w
	addwfc	adacch,f
	return
; a nyolc mintavtel az tlagolssal
ad8
	banksel	adcon0
	movlw	8
	movwf	adcnt	; ennyi mintavtel lesz
	clrf	adacch	; k a gyjtk
	clrf	adaccl
ad8lp
	call	ad1	; egy j mrst hozzad a gyjthz
	decfsz	adcnt,f
	goto	ad8lp	; amg a nyolc el nem fogy
	banksel	lata
	bsf	inh	; ram vissza 1 uA-re, amint lehet
	banksel	adcon0
	clc
	rrf	adacch,f
	rrf	adaccl,f
	bcf	sok
	movf	adaccl,w
	xorlw	0xfc
	snz
	bsf	sok	; als bjt=fc
	movf	adacch,w
	xorlw	0x0f
	sz
	bcf	sok	; kivve, ha a fels nem 0f
	banksel	0
	btfss	range
	goto	led
	banksel	adacch
	rrf	adacch,f	; range=1 miatt 4-gyel osztand
	rrf	adaccl,f
	rrf	adacch,f
	rrf	adaccl,f
led
	banksel	adacch
	movlw	0x0f
	andwf	adacch,f	; 12 bitre korltozva
; sszellt a 10-12 bites eredmny
	movf	adacch,w
	movwf	ah
	movf	adaccl,w
	movwf	al
	call	bibcd16
	movlw	low ch
	movwf	fsr0l
	snb	sok
	goto	replace
	call	binhexu
	call	binhexu
pv
	movlw	s_c
	movwi	fsr1++
	return
replace
	movlw	'9'
	movwi	fsr1++
	movwi	fsr1++
	movwi	fsr1++
	movwi	fsr1++
	bcf	sok
	goto	pv
	
testrun
	snb	m_stop	
	goto	main
	goto	testrun
	bsf	test
	movlw	high ascbuf
	movwf	fsr1h
	movlw	low ascbuf
	movwf	fsr1l
	movlw	'T'
	movwi	fsr1++
	movlw	'S'
	movwi	fsr1++
	movlw	'T'
	movwi	fsr1++
	movlw	s_c
	movwi	fsr1++	; sorszm s pontosvessz a helyn	
	goto	alap	
	
serini	
	banksel	baud1con
	movl	baud1con,8
	movl	rc1sta,90h	; enable
	movl	tx1sta,26h	; enable
	movl	spbrgl,103	; 9600 bps, kb. 1 karakter/ms
	clrf	spbrgh
	return
	
its
	retfie
		
	#include <conv.inc>	
	
	end
